#ifndef _COBJMESSAGERESIZE_H_
#define _COBJMESSAGERESIZE_H_


#include "CObjMessage.h"

#define NB_OF_RESIZE		2					//nombre de directions prdfinies
#define DIR_HORIZONTAL		1					//direction horizontale oriente vers la droite
#define DIR_VERTICAL		2					//direction verticale oriente vers le haut


class CObjMessageResize:public CObjMessage
{
private:
	int direction;								//direction du resize
	int minOffset;								//valeur de l'cart du resize sur la borne infrieure
	int maxOffset;								//valeur de l'cart du resize sur la borne suprieure

public:
	CObjMessageResize(int direction, int min, int max, int redrawobject);	//constructeur
	virtual ~CObjMessageResize();				//destructeur

	int GetDirection();							//retourne la direction du resize
	int GetMinOffset();							//retourne la valeur de l'cart du resize sur la borne infrieure
	int GetMaxOffset();							//retourne la valeur de l'cart du resize sur la borne suprieure
};


#endif