/*****************************************************************************/
/* htmlrow.cpp - 18/08/99 - By Christophe LOREK - CRYO-NETWORKS              */
/*                                                                           */
/* HTMLROW class                                                             */
/*                                                                           */
/* last modified on 18/08/99 By Christophe LOREK                             */
/*****************************************************************************/

#ifdef HTML_INCLUDE

#include "htmlrow.h"


HTMLROW::HTMLROW(mmachine m,
										 int givenalign,
										 int givenred,
										 int givengreen,
										 int givenblue,
										 int givenwidth,
										 int givencols,
										 int givenborder,
										 int givenframe,
										 int givenrules,
										 int givencellspacing,
										 int givencellpadding)
{
	int				structbuf;
	int				nodetab;

	x = 0;
	y = 0;
	w = givenwidth;
	h = 0;
	cx = 0;
	cy = 0;

	align				= givenalign;
	red					= givenred;
	green				= givengreen;
	blue				= givenblue;	
	cols				= givencols;
	border			= givenborder;
	frame				= givenframe;
	rules				= givenrules;
	cellspacing	= givencellspacing;
	cellpadding	= givencellpadding;


// creating struct buffer
	structbuf = MMmalloc(m,NODESTRUCT_BUFSIZE,TYPEBUF);
	MMstore(m,structbuf,NODESTRUCT_STRUCT,(int)this);
	MMpush(m,1+(structbuf<<1));

// creating table node
	nodetab = MMmalloc(m,NODE_SIZE,TYPETAB);
	MMstore(m,nodetab,NODE_TYPE,NODE_TYPROW<<1);
	MMstore(m,nodetab,NODE_FATHER,NIL);
	MMstore(m,nodetab,NODE_OBJBITMAP,NIL);
	MMstore(m,nodetab,NODE_STRUCT,MMpull(m));
	MMstore(m,nodetab,NODE_BROTHER,MMpull(m));
	MMstore(m,nodetab,NODE_SON,MMpull(m));
	MMpush(m,1+(nodetab<<1));

//	DRAWrow();
}

HTMLROW::~HTMLROW()
{

}

int HTMLROW::DRAWrow()
{
	MMechostr(MSKFOO,"HTMLROW\n");
	return 0;
}

int HTMLROW::Align()
{
	return align;
}

int HTMLROW::Red()
{
	return red;
}

int HTMLROW::Green()
{
	return green;
}

int HTMLROW::Blue()
{
	return blue;
}

int HTMLROW::Cols()
{
	return cols;
}

int HTMLROW::Border()
{
	return border;
}

int HTMLROW::Frame()
{
	return frame;
}

int HTMLROW::Rules()
{
	return rules;
}

int HTMLROW::Cellspacing()
{
	return cellspacing;
}

int HTMLROW::Cellpadding()
{
	return cellpadding;
}

#endif