/*****************************************************************************/
/* node.h - 03/08/99 - By Christophe LOREK - CRYO-NETWORKS                   */
/*                                                                           */
/* node constants definitions.                                               */
/*                                                                           */
/* last modified on 03/08/99 By Christophe LOREK                             */
/*****************************************************************************/

#ifndef NODE_H
#define NODE_H

// Number of fields in Node
#define	OBJHTML_SIZE		2
// Node offsets definition
#define	OBJHTML_HANDLER	0
#define OBJHTML_NODE		1

// Number of fields in Node
#define	NODE_SIZE				6
// Node offsets definition
#define	NODE_TYPE				0
#define NODE_FATHER			1
#define	NODE_BROTHER		2
#define	NODE_SON				3
#define	NODE_STRUCT			4
#define	NODE_OBJBITMAP	5

#define NODESTRUCT_BUFSIZE	1
#define	NODESTRUCT_STRUCT		0

#define	NODE_TYPHTML		0
#define	NODE_TYPBITMAP	1
#define	NODE_TYPTEXT		2
#define	NODE_TYPTABLE		3
#define	NODE_TYPROW			4
#define	NODE_TYPCELL		5

#endif